//******************************************************************************
//
// SysEx2CS / SEKuchiPakuCtrl
//
// ςNX
//
// Copyright (C) 2023 WADA Masashi. All Rights Reserved.
//
//******************************************************************************

#pragma once

#include "YNBaseLib.h"
#include "SESysExOutCtrl.h"
#include <list>

using namespace YNBaseLib;
using namespace SMIDILib;


//******************************************************************************
// p[^`
//******************************************************************************
//̌`
#define SE_CS_FACE_MOUTH_CLOSE              (0)     //
#define SE_CS_FACE_MOUTH_A                  (1)     //
#define SE_CS_FACE_MOUTH_I                  (2)     //
#define SE_CS_FACE_MOUTH_U                  (3)     //
#define SE_CS_FACE_MOUTH_E                  (4)     //
#define SE_CS_FACE_MOUTH_O                  (5)     //
#define SE_CS_FACE_MOUTH_MID                (8)     //

//ςԊu
#define SE_KUCHIPAKU_INTERVAL_NORMAL_MSEC   (200)   /////X 1߂̎ԊԊu 0.2b
#define SE_KUCHIPAKU_INTERVAL_SOKUON_MSEC   (300)   //uvƂ̎ԊԊu 0.3b
#define SE_KUCHIPAKU_INTERVAL_CHOUON_MSEC   (400)   //u[vƂ̎ԊԊu 0.4b
#define SE_KUCHIPAKU_INTERVAL_KUTOUTEN_MSEC (400)   //Ǔ_̎ԊԊu 0.4b

//ςx
#define SE_KUCHIPAKU_SPEED_RATIO_NORMAL	    (1.0)   //ӂ
#define SE_KUCHIPAKU_SPEED_RATIO_SLOW       (0.5)   //
#define SE_KUCHIPAKU_SPEED_RATIO_FAST       (1.5)   //

//^C}[ID
#define SE_TIMER_KUCHI_PAKU_NEXT            (1)


//******************************************************************************
// CureSynthc[_CAONX
//******************************************************************************
class SEKuchiPakuCtrl
{
public:

	//RXgN^^fXgN^
	SEKuchiPakuCtrl(void);
	virtual ~SEKuchiPakuCtrl(void);

	//
	int Initialize(HWND hWnd, SESysExOutCtrl* pSysExOutCtrl);

	//ςJn
	int StartKuchiPaku(const char* pStr, float speedRatio);

	//^C}[ʒm
	int OnTimer();

private:

	//
	enum SingleCharType {
		Seion,			//
		Dakuon,			//
		Youon,			//X
		Sokuon,			//
		Chouonpu,		//
		Kutouten,		//Ǔ_
		Other			//̑
	};

	//̌`
	enum MouthShape {
		Mouth_Close,	//
		Mouth_A,		//
		Mouth_I,		//
		Mouth_U,		//
		Mouth_E,		//
		Mouth_O,		//
		Mouth_MID,		//
		Mouth_Keep		//̂܂
	};

	//ςR}h
	typedef struct {
		unsigned char mouthImage;
		unsigned long intervalMSec;
		char displayString[8];
	} SEKuchiPakuCommand;

	//ςR}hXg
	typedef std::list<SEKuchiPakuCommand> SEKuchiPakuCommandList;
	SEKuchiPakuCommandList m_KuchiPakuCommandList;

	//ςR}hCfbNX
	unsigned long m_KuchiPakuCommadIndex;

	//MςݕTCY
	size_t m_OutputCharSize;

	//ςxiW1.0j
	float m_SpeedRatio;

	//EBhEnh
	HWND m_hWnd;

	//SysExo͐IuWFNg
	SESysExOutCtrl* m_pSysExOutCtrl;


	int _MakeCommandList(const char* pStr);
	int _GetSingleChar(const char* pStr, char* singleChar);
	bool _IsSJISLeadByte(char c);
	void _CheckSingleCharAttr(
			char* pSingleChar,
			SingleCharType* pSingleCharType,
			MouthShape* pMouthShape
		);
	bool _IsExistInList(
			char* pSingleCharList,
			char* pSingleChar
		);
	unsigned char _GetMouthImage(
			MouthShape mouthShape,
			unsigned char curMouthImage
		);

	int _ExecCommand(SEKuchiPakuCommand command);

};


