//******************************************************************************
//
// SysEx2CS / SESysExOutCtrl
//
// SysExo͐NX
//
// Copyright (C) 2023 WADA Masashi. All Rights Reserved.
//
//******************************************************************************

#pragma once

#include "YNBaseLib.h"
#include "SMIDILib.h"

using namespace YNBaseLib;
using namespace SMIDILib;

//******************************************************************************
// p[^`
//******************************************************************************
//Oo͍ős
#define SE_LOG_COUNT_MAX	(10000)


//******************************************************************************
// CureSynthc[_CAONX
//******************************************************************************
class SESysExOutCtrl
{
public:

	//RXgN^^fXgN^
	SESysExOutCtrl(void);
	virtual ~SESysExOutCtrl(void);

	//
	int Initialize(SMOutDevCtrl* pOutDevCtrl, HWND hLogListBox);

	//CureSynthZbg
	int SendCSReset();

	//GM System ON
	int SendGMSystemOn();

	//GS Reset
	int SendGSReset();

	//XG System On
	int SendXGSystemOn();

	//UI Type
	int SendCSUIType(unsigned char type);

	//
	int SendCSFace(unsigned char part, unsigned char image);

	// ܂΂
	int SendCSFaceBlinking(unsigned char status);

	//{\[h
	int SendCSJPCharMode(unsigned char status);

	//{ꕶǉ
	int SendCSJPCharAdd(
			unsigned char row,
			char* pStr
		);

	//{ꕶ폜
	int SendCSJPCharDel(unsigned char row);

private:

	//MIDIo̓foCXIuWFNg
	SMOutDevCtrl* m_pOutDevCtrl;

	//Oo͗pXg{bNX
	HWND m_hLogListBox;

	//SysExM
	int _SendSysEx(
			unsigned char* pData,
			unsigned long size,
			const char* pComment
		);

	//Oo
	int _OutputLog(const char* pStr);

};


