//******************************************************************************
//
// SysEx2CS / SysEx2CSDlg
//
// SysEx2CS_CAONX
//
// Copyright (C) 2023 WADA Masashi. All Rights Reserved.
//
//******************************************************************************

#include "framework.h"
#include "resource.h"
#include "Commdlg.h"
#include "mbctype.h"
#include "imagehlp.h"
#include "SysEx2CSDlg.h"


//******************************************************************************
// EBhEvV[Wpp[^ݒ
//******************************************************************************
SysEx2CSDlg* SysEx2CSDlg::m_pThis = NULL;

//******************************************************************************
// RXgN^
//******************************************************************************
SysEx2CSDlg::SysEx2CSDlg(void)
{
	unsigned long type = 0;

	m_pThis = this;
	m_hWnd = NULL;
	m_hComboMIDIOUT = NULL;
	m_hEditJPChar1 = NULL;
	m_hEditJPChar2 = NULL;
	m_hEditJPKuchipaku = NULL;
	m_hComboKuchipakuSpeed = NULL;
	m_hLogListBox = NULL;

	return;
}

//******************************************************************************
// fXgN^
//******************************************************************************
SysEx2CSDlg::~SysEx2CSDlg(void)
{
}

//******************************************************************************
// \
//******************************************************************************
int SysEx2CSDlg::Show()
{
	int result = 0;
	INT_PTR dresult = 0;

	//_CAO\
	dresult = DialogBoxA(
					NULL,								//CX^Xnh
					MAKEINTRESOURCE(IDD_SYSEX2CS_DLG),	//_CAO{bNXev[g
					NULL,								//eEBhEnh
					_WndProc							//_CAO{bNXvV[W
				);
	if ((dresult == 0) || (dresult == -1)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

EXIT:;
	return result;
}

//******************************************************************************
// EBhEvV[W
//******************************************************************************
INT_PTR CALLBACK SysEx2CSDlg::_WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	return m_pThis->_WndProcImpl(hWnd, message, wParam, lParam);
}

//******************************************************************************
// EBhEvV[WF
//******************************************************************************
INT_PTR SysEx2CSDlg::_WndProcImpl(
		HWND hDlg,
		UINT message,
		WPARAM wParam,
		LPARAM lParam
	)
{
	int result = 0;
	LRESULT lresult = 0;

	UNREFERENCED_PARAMETER(lParam);

	switch (message) {
		case WM_INITDIALOG:
			result = _OnInitDlg(hDlg);
			if (result != 0) goto EXIT;
			break;
		case WM_COMMAND:
			//--------------------------------------------------------
			// _CAO
			//--------------------------------------------------------
			if (LOWORD(wParam) == IDC_BTN_CLOSE) {
				EndDialog(hDlg, LOWORD(wParam));
			}
			else if (LOWORD(wParam) == IDCANCEL) {
				EndDialog(hDlg, LOWORD(wParam));
			}
			//--------------------------------------------------------
			// MIDIo̓foCX
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CONNECT) {
				result = _OnBtnConnect();
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// VXe
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_RESET) {
				result = _OnBtnCSReset();
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_GM_SYSTEM_ON) {
				result = _OnBtnGMSystemOn();
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_GS_RESET) {
				result = _OnBtnGSReset();
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_XG_SYSTEM_ON) {
				result = _OnBtnXGSystemOn();
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// UI^Cv
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_UITYPE_INIT) {
				result = _OnBtnCSUIType(0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_UITYPE_LIPSYNC) {
				result = _OnBtnCSUIType(1);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_UITYPE_PIANOROLL) {
				result = _OnBtnCSUIType(2);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_UITYPE_OSCILLOSCOPE) {
				result = _OnBtnCSUIType(3);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// 
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_DEFAULT) {
				result = _OnBtnCSFace(0, 0);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// F
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYEBROW_NORMAL) {
				result = _OnBtnCSFace(1, 0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYEBROW_TENDER) {
				result = _OnBtnCSFace(1, 1);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYEBROW_SAD) {
				result = _OnBtnCSFace(1, 2);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYEBROW_ANGRY) {
				result = _OnBtnCSFace(1, 3);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// F
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYE_NORMAL) {
				result = _OnBtnCSFace(2, 0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYE_MIDDLE) {
				result = _OnBtnCSFace(2, 1);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYE_CLOSE) {
				result = _OnBtnCSFace(2, 2);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYE_SMILE) {
				result = _OnBtnCSFace(2, 3);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYE_DAME) {
				result = _OnBtnCSFace(2, 4);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYE_SHIITAKE) {
				result = _OnBtnCSFace(2, 5);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_EYE_WINK) {
				result = _OnBtnCSFace(2, 6);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// F
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_CLOSE) {
				result = _OnBtnCSFace(3, 0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_A) {
				result = _OnBtnCSFace(3, 1);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_I) {
				result = _OnBtnCSFace(3, 2);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_U) {
				result = _OnBtnCSFace(3, 3);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_E) {
				result = _OnBtnCSFace(3, 4);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_O) {
				result = _OnBtnCSFace(3, 5);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_PEKO) {
				result = _OnBtnCSFace(3, 6);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_BLAME) {
				result = _OnBtnCSFace(3, 7);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_MOUTH_MID) {
				result = _OnBtnCSFace(3, 8);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// F܂΂[h
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_BLINKING_OFF) {
				result = _OnBtnCSFaceBlinking(0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_FACE_BLINKING_ON) {
				result = _OnBtnCSFaceBlinking(1);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// {\[h
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_CHAR_MODE_OFF) {
				result = _OnBtnCSJPCharMode(0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_CHAR_MODE_ON) {
				result = _OnBtnCSJPCharMode(1);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// {\[hFǉ
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_CHAR_ADD1) {
				result = _OnBtnCSJPCharAdd(0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_CHAR_ADD2) {
				result = _OnBtnCSJPCharAdd(1);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// {\[hF폜
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_CHAR_DEL0) {
				result = _OnBtnCSJPCharDel(0);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_CHAR_DEL1) {
				result = _OnBtnCSJPCharDel(1);
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_CHAR_DEL2) {
				result = _OnBtnCSJPCharDel(2);
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// ς
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_CS_JP_PAKUPAKU) {
				result = _OnBtnCSJPKuchipaku();
				if (result != 0) goto EXIT;
			}
			//--------------------------------------------------------
			// O
			//--------------------------------------------------------
			else if (LOWORD(wParam) == IDC_BTN_LOG_CLEAR) {
				result = _OnBtnLogClear();
				if (result != 0) goto EXIT;
			}
			else if (LOWORD(wParam) == IDC_BTN_LOG_COPY) {
				result = _OnBtnLogCopy();
				if (result != 0) goto EXIT;
			}
			break;
		case WM_TIMER:
			//--------------------------------------------------------
			//ς^C}[
			//--------------------------------------------------------
			if (wParam == SE_TIMER_KUCHI_PAKU_NEXT) {
				result = m_KuchiPakuCtrl.OnTimer();
				if (result != 0) goto EXIT;
			}
			break;
		default:
			//ȂbZ[W
			break;
	}

EXIT:;
	if (result != 0) {
		YN_SHOW_ERR(hDlg);
	}
	return lresult;
}

//******************************************************************************
// _CAO\O
//******************************************************************************
int SysEx2CSDlg::_OnInitDlg(
		HWND hDlg
	)
{
	int result = 0;

	m_hWnd = hDlg;

	//MIDIo̓foCXR{{bNX
	m_hComboMIDIOUT =  GetDlgItem(hDlg, IDC_CMB_MIDIOUT_DEVICE);

	//{ꕶ
	m_hEditJPChar1 = GetDlgItem(hDlg, IDC_EDIT_CS_JP_CHAR1);
	m_hEditJPChar2 = GetDlgItem(hDlg, IDC_EDIT_CS_JP_CHAR2);

	//ς
	m_hEditJPKuchipaku = GetDlgItem(hDlg, IDC_EDIT_CS_JP_KUCHIPAKU);

	//ςxR{{bNX
	m_hComboKuchipakuSpeed = GetDlgItem(hDlg, IDC_CMB_CS_JP_KUCHIPAKU_SPEED);

	//OXg{bNX
	m_hLogListBox = GetDlgItem(hDlg, IDC_LIST_LOG);

	//MIDIo̓foCX䏉
	result = m_OutDevCtrl.Initialize();
	if (result != 0) goto EXIT;

	//SysExMIuWFNg
	result = m_SysExOutCtrl.Initialize(&m_OutDevCtrl, m_hLogListBox);
	if (result != 0) goto EXIT;

	//MIDIo̓foCXR{{bNX
	result = _InitComboMIDIDevice(m_hComboMIDIOUT);
	if (result != 0) goto EXIT;

	//ςxR{{bNX
	result = _InitComboKuchipakuSpeed(m_hComboKuchipakuSpeed);

	//Xg{bNX̐XN[o[̕\͈͎w
	SendMessage(m_hLogListBox, LB_SETHORIZONTALEXTENT, 1600, 0);

	//ς䏉
	result = m_KuchiPakuCtrl.Initialize(m_hWnd, &m_SysExOutCtrl);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// foCXIR{{bNX
//******************************************************************************
int SysEx2CSDlg::_InitComboMIDIDevice(HWND hComboDev)
{
	int result = 0;
	LRESULT lresult = 0;
	unsigned long index = 0;
	unsigned long devNum = 0;
	int comboIndex = 0;
	int selectedIndex = 0;
	std::string productName;

	//uIȂvR{{bNXɒǉ
	lresult = SendMessage(hComboDev, CB_ADDSTRING, 0, (LPARAM)_T("(none)"));
	if ((lresult == CB_ERR) || (lresult == CB_ERRSPACE)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)hComboDev);
		goto EXIT;
	}
	comboIndex++;

	//MIDIfoCXR{{bNXɒǉ
	devNum = m_OutDevCtrl.GetDevNum();
	for (index = 0; index < devNum; index++) {
		//MIDI OUTfoCX擾
		result = m_OutDevCtrl.GetDevProductName(index, productName);
		if (result != 0) goto EXIT;

		//foCXR{{bNXɒǉ
		lresult = SendMessage(hComboDev, CB_ADDSTRING, 0, (LPARAM)productName.c_str());
		if ((lresult == CB_ERR) || (lresult == CB_ERRSPACE)) {
			result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)hComboDev);
			goto EXIT;
		}
		comboIndex++;
	}

	//IԐݒ
	lresult = SendMessage(hComboDev, CB_SETCURSEL, selectedIndex, 0);
	if (lresult == CB_ERR) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), selectedIndex);
		goto EXIT;
	}

EXIT:;
	return result;
}

//******************************************************************************
// ςxR{{bNX
//******************************************************************************
int SysEx2CSDlg::_InitComboKuchipakuSpeed(HWND hCombo)
{
	int result = 0;
	LRESULT lresult = 0;
	int selectedIndex = 0;

	//R{{bNXɍڒǉ
	lresult = SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)_T("ӂ"));
	if ((lresult == CB_ERR) || (lresult == CB_ERRSPACE)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)hCombo);
		goto EXIT;
	}
	lresult = SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)_T(""));
	if ((lresult == CB_ERR) || (lresult == CB_ERRSPACE)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)hCombo);
		goto EXIT;
	}
	lresult = SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)_T(""));
	if ((lresult == CB_ERR) || (lresult == CB_ERRSPACE)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)hCombo);
		goto EXIT;
	}

	//IԐݒ
	lresult = SendMessage(hCombo, CB_SETCURSEL, selectedIndex, 0);
	if (lresult == CB_ERR) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), selectedIndex);
		goto EXIT;
	}

EXIT:;
	return result;
}

//******************************************************************************
// MIDIo̓foCXڑ{^
//******************************************************************************
int SysEx2CSDlg::_OnBtnConnect()
{
	int result = 0;
	LRESULT lresult = 0;
	unsigned long selectedIndex = 0;
	std::string selectedProductName;

	//Iڂ̃CfbNX擾
	lresult = SendMessage(m_hComboMIDIOUT, CB_GETCURSEL, 0, 0);
	if ((lresult == CB_ERR) || (lresult < 0)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)m_hComboMIDIOUT);
		goto EXIT;
	}
	selectedIndex = (unsigned long)lresult;

	//foCX
	result = m_OutDevCtrl.ClosePortDevAll();
	if (result != 0) goto EXIT;

	//IȂ牽Ȃ
	if (selectedIndex == 0) goto EXIT;

	//IꂽfoCX̖̂擾
	result = m_OutDevCtrl.GetDevProductName((selectedIndex-1), selectedProductName);
	if (result != 0) goto EXIT;

	//|[gAɑIꂽfoCXݒ
	result = m_OutDevCtrl.SetPortDev(0, selectedProductName.c_str());
	if (result != 0) goto EXIT;

	//foCXJ
	result = m_OutDevCtrl.OpenPortDevAll();
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^FCureSynthZbg
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSReset()
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendCSReset();
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^FGM System ON
//******************************************************************************
int SysEx2CSDlg::_OnBtnGMSystemOn()
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendGMSystemOn();
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^FGS Reset
//******************************************************************************
int SysEx2CSDlg::_OnBtnGSReset()
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendGSReset();
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^FXG System On
//******************************************************************************
int SysEx2CSDlg::_OnBtnXGSystemOn()
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendXGSystemOn();
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^FUI Type
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSUIType(unsigned char type)
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendCSUIType(type);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^F
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSFace(unsigned char part, unsigned char image)
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendCSFace(part, image);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^F ܂΂
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSFaceBlinking(unsigned char status)
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendCSFaceBlinking(status);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^F{\[h
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSJPCharMode(unsigned char status)
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendCSJPCharMode(status);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^F{ꕶǉ
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSJPCharAdd(unsigned char row)
{
	int result = 0;
	int apiresult = 0;
	HWND hEdit = NULL;
	char str[256] = { '\0' };

	//͕擾ΏۃGfBbg{bNX
	if (row == 0) {
		hEdit = m_hEditJPChar1;
	}
	else if (row == 1) {
		hEdit = m_hEditJPChar2;
	}

	//͕擾
	apiresult = GetWindowTextA(hEdit, (LPSTR)str, 256);
	if (apiresult == 0) {
		//eLXg܂̓EBhEnh̏ꍇ
		str[0] = '\0';
	}

	//SysExM
	result = m_SysExOutCtrl.SendCSJPCharAdd(row, str);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^F{ꕶ폜
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSJPCharDel(unsigned char row)
{
	int result = 0;

	//SysExM
	result = m_SysExOutCtrl.SendCSJPCharDel(row);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// {^Fς
//******************************************************************************
int SysEx2CSDlg::_OnBtnCSJPKuchipaku()
{
	int result = 0;
	int apiresult = 0;
	LRESULT lresult = 0;
	unsigned long selectedIndex = 0;
	float speedRatio = 1.0f;
	char str[256] = { '\0' };

	//͕擾
	apiresult = GetWindowTextA(m_hEditJPKuchipaku, (LPSTR)str, 256);
	if (apiresult == 0) {
		//eLXg܂̓EBhEnh̏ꍇ
		str[0] = '\0';
	}

	//Iڂ̃CfbNX擾
	lresult = SendMessage(m_hComboKuchipakuSpeed, CB_GETCURSEL, 0, 0);
	if ((lresult == CB_ERR) || (lresult < 0)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)m_hComboKuchipakuSpeed);
		goto EXIT;
	}
	selectedIndex = (unsigned long)lresult;
	if (selectedIndex == 0) {
		//ӂ
		speedRatio = SE_KUCHIPAKU_SPEED_RATIO_NORMAL;
	}
	else if (selectedIndex == 1) {
		//
		speedRatio = SE_KUCHIPAKU_SPEED_RATIO_SLOW;
	}
	else {
		//΂₭
		speedRatio = SE_KUCHIPAKU_SPEED_RATIO_FAST;
	}

	//ςJn
	result = m_KuchiPakuCtrl.StartKuchiPaku(str, speedRatio);
	if (result != 0) goto EXIT;

EXIT:;
	return result;
}

//******************************************************************************
// OFNA
//******************************************************************************
int SysEx2CSDlg::_OnBtnLogClear()
{
	int result = 0;
	int apiresult = 0;
	LRESULT lresult = 0;

	//₢킹
	apiresult = MessageBox(m_hWnd, _T("ONA܂H"), _T("mF"), MB_OKCANCEL);
	if (apiresult == 0) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}
	else if (apiresult != IDOK) {
		goto EXIT;
	}

	//ONA
	lresult = SendMessage(m_hLogListBox, LB_RESETCONTENT, 0, 0);
	if (lresult == LB_ERR) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)lresult);
		goto EXIT;
	}

EXIT:;
	return 0;
}

//******************************************************************************
// OFRs[
//******************************************************************************
int SysEx2CSDlg::_OnBtnLogCopy()
{
	int result = 0;
	LRESULT lresult = 0;
	size_t listCount = 0;
	size_t i = 0;
	char str[2048] = { '\0' };
	std::string strBuff;

	//Xgs擾
	lresult = SendMessage(m_hLogListBox, LB_GETCOUNT, 0, 0);
	if (lresult == LB_ERR) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)lresult);
		goto EXIT;
	}
	listCount = lresult;

	//XgׂĎ擾
	for (i = 0; i < listCount; i++) {
		//TOOD: LB_GETTEXTLEN ŎOɕ̒mFׂ
		lresult = SendMessage(m_hLogListBox, LB_GETTEXT, i, (LPARAM)(LPTSTR)str);
		if (lresult == LB_ERR) {
			result = YN_SET_ERR("Windows API error.", GetLastError(), (DWORD64)i);
			goto EXIT;
		}
		strBuff += str;
		strBuff += "\n";
	}

	//Nbv{[hɓo^
	result = _CopyToClipboard(strBuff.c_str());
	if (result != 0) goto EXIT;

EXIT:;
	return 0;
}

//******************************************************************************
// Nbv{[ho^
//******************************************************************************
int SysEx2CSDlg::_CopyToClipboard(const char* pStr)
{
	int result = 0;
	size_t buffSize = 0;
	BOOL bresult = FALSE;
	HANDLE hData = NULL;
	HGLOBAL hGlobalMemory;
	TCHAR* pGlobalMemory = NULL;
	
	//m
	buffSize = _tcslen(pStr) + 1;
	hGlobalMemory = GlobalAlloc(GHND, buffSize);
	if (hGlobalMemory == NULL) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

	//bN
	pGlobalMemory = (LPSTR)GlobalLock(hGlobalMemory);
	if (pGlobalMemory == NULL) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

	//Ƀp[^
	_tcscat_s(pGlobalMemory, buffSize, pStr);

	//bN
	bresult = GlobalUnlock(hGlobalMemory);
	if ((!bresult) && (GetLastError() != NO_ERROR)) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

	//Nbv{[hJ
	bresult = OpenClipboard(m_hWnd);
	if (!bresult) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

	//Nbv{[hNA
	bresult = EmptyClipboard();
	if (!bresult) {
		CloseClipboard();
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

	//Nbv{[hɃf[^o^
	hData = SetClipboardData(CF_TEXT, hGlobalMemory);
	if (hData == NULL) {
		CloseClipboard();
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

	//Nbv{[hւ̃f[^o^߃ǗOSɈp
	hGlobalMemory = NULL;

	//Nbv{[h
	bresult = CloseClipboard();
	if (!bresult) {
		result = YN_SET_ERR("Windows API error.", GetLastError(), 0);
		goto EXIT;
	}

EXIT:;
	if (hGlobalMemory != NULL) {
		GlobalFree(hGlobalMemory);
	}
	return result;
}

