//******************************************************************************
//
// SysEx2CS / SysEx2CSDlg
//
// SysEx2CS_CAONX
//
// Copyright (C) 2023 WADA Masashi. All Rights Reserved.
//
//******************************************************************************

#pragma once

#include "YNBaseLib.h"
#include "SMIDILib.h"
#include "SESysExOutCtrl.h"
#include "SEKuchiPakuCtrl.h"

using namespace YNBaseLib;
using namespace SMIDILib;


//******************************************************************************
// p[^`
//******************************************************************************


//******************************************************************************
// SysEx2CS_CAONX
//******************************************************************************
class SysEx2CSDlg
{
public:

	//RXgN^^fXgN^
	SysEx2CSDlg(void);
	virtual ~SysEx2CSDlg(void);

	//\F_CAO܂ŐԂȂ
	int Show();

private:

	//EBhEvV[Wp|C^
	static SysEx2CSDlg* m_pThis;

	//EBhEnh
	HWND m_hWnd;

	//ݒt@C
	YNConfFile m_ConfFile;
	YNConfFile m_MIDIConf;

	//MIDIo̓foCXR{{bNX
	HWND m_hComboMIDIOUT;

	//{ꕶGfBbg{bNX
	HWND m_hEditJPChar1;
	HWND m_hEditJPChar2;

	//ςGfBbg{bNX
	HWND m_hEditJPKuchipaku;

	//ςxR{{bNX
	HWND m_hComboKuchipakuSpeed;

	//OXg{bNX
	HWND m_hLogListBox;

	//MIDIo̓foCXIuWFNg
	SMOutDevCtrl m_OutDevCtrl;

	//SysExMIuWFNg
	SESysExOutCtrl m_SysExOutCtrl;

	//ςIuWFNg
	SEKuchiPakuCtrl m_KuchiPakuCtrl;

	//EBhEvV[W
	static INT_PTR CALLBACK _WndProc(HWND, UINT, WPARAM, LPARAM);
	INT_PTR _WndProcImpl(const HWND hWnd, const UINT message, const WPARAM wParam, const LPARAM lParam);

	//_CAO
	int _OnInitDlg(HWND hDlg);
	int _InitComboMIDIDevice(HWND hComboDev);
	int _InitComboKuchipakuSpeed(HWND hCombo);

	//Cxgnh
	int _OnBtnConnect();
	int _OnBtnCSReset();
	int _OnBtnGMSystemOn();
	int _OnBtnGSReset();
	int _OnBtnXGSystemOn();
	int _OnBtnCSUIType(unsigned char type);
	int _OnBtnCSFace(unsigned char part, unsigned char image);
	int _OnBtnCSFaceBlinking(unsigned char status);
	int _OnBtnCSJPCharMode(unsigned char status);
	int _OnBtnCSJPCharAdd(unsigned char row);
	int _OnBtnCSJPCharDel(unsigned char row);
	int _OnBtnCSJPKuchipaku();
	int _OnBtnLogClear();
	int _OnBtnLogCopy();

	//Nbv{[ho^
	int _CopyToClipboard(const char* pStr);

};


